function f=n_body_func(t, y)

global m;
global G;

d = 2;

nd = length(y)/2;
n = nd/2;

if( length(m)~= n)
   error('dimension mismatch');
end

f = zeros(2*nd, 1);

f(1:nd) = y(nd+1:end);

for i=1:n
   qi = y(d*(i-1)+1:d*i);

   sumson = zeros(d, 1);

   for k=setdiff((1:n), i)
      qk = y(d*(k-1)+1:d*k);

      r = norm(qk - qi);
      q_ki = (qk-qi)/r;

      sumson = sumson + m(k) * q_ki / (r^2);
   end

   f(nd+d*(i-1)+1:nd+d*i) = G*sumson;
end

